#include<malloc.h>
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
#include"nr.h"
#include"nrutil.h"

#define PI 3.141592653589793


main()
{    float dum,delta,alpha,fact,*w,delrho;
     int lattice_size_x,lattice_size_y,*nn,i,j;
     FILE *fp1,*fp2;

     fp1=fopen("load2dandes","r");
     fp2=fopen("load2dandesdeflect50","w");
     lattice_size_x=2048;
     lattice_size_y=4096;
     delta=1.1;   /* km */
     alpha=50.0;  /* (4D/((rho_m-rho_c)*g))^0.25, in units of multiples of delta */
     delrho=0.27; /* (rho_m-rho_c)/rho_c */
     nn=ivector(1,2);
     nn[1]=lattice_size_x;
     nn[2]=lattice_size_y;
     w=vector(1,2*lattice_size_x*lattice_size_y);
     for (j=1;j<=lattice_size_y;j++)
      for (i=1;i<=lattice_size_x;i++)
       {fscanf(fp1,"%f",&dum);
        if (dum<1000) w[2*(i-1)*lattice_size_y+2*j-1]=0;
         else w[2*(i-1)*lattice_size_y+2*j-1]=dum;
        w[2*(i-1)*lattice_size_y+2*j]=0.0;}
     fourn(w,nn,2,1);
     w[1]*=1/delrho;
     w[2]*=1/delrho;
     for (j=1;j<=lattice_size_y/2;j++)
      {fact=1/(delrho+4*delrho*pow(alpha*j*PI/lattice_size_y,4.0));
       w[2*j+1]*=fact;
       w[2*j+2]*=fact;
       w[2*lattice_size_y-2*j+1]*=fact;
       w[2*lattice_size_y-2*j+2]*=fact;}
     for (i=1;i<=lattice_size_x/2;i++)
      {fact=1/(delrho+4*delrho*pow(alpha*i*PI/lattice_size_x,4.0));
       w[2*i*lattice_size_y+1]*=fact;
       w[2*i*lattice_size_y+2]*=fact;
       w[2*lattice_size_x*lattice_size_y-2*i*lattice_size_y+1]*=fact;
       w[2*lattice_size_x*lattice_size_y-2*i*lattice_size_y+2]*=fact;}
     for (i=1;i<=lattice_size_x/2;i++)
      for (j=1;j<=lattice_size_y/2;j++)
       {fact=1/(delrho+4*delrho*pow(alpha*sqrt((PI*PI*i*i)/(lattice_size_x*lattice_size_x)+
         (PI*PI*j*j)/(lattice_size_y*lattice_size_y)),4.0));
        w[2*i*lattice_size_y+2*j+1]*=fact;
        w[2*i*lattice_size_y+2*j+2]*=fact;
        w[2*i*lattice_size_y+2*lattice_size_y-2*j+1]*=fact;
        w[2*i*lattice_size_y+2*lattice_size_y-2*j+2]*=fact;
        w[2*lattice_size_x*lattice_size_y-2*(i-1)*lattice_size_y-
          2*(lattice_size_y-j)+1]*=fact;
        w[2*lattice_size_x*lattice_size_y-2*(i-1)*lattice_size_y-
          2*(lattice_size_y-j)+2]*=fact;
        w[2*lattice_size_x*lattice_size_y-2*lattice_size_y-
          2*(i-1)*lattice_size_y+2*(lattice_size_y-j)+1]*=fact;
		w[2*lattice_size_x*lattice_size_y-2*lattice_size_y-
          2*(i-1)*lattice_size_y+2*(lattice_size_y-j)+2]*=fact;}
     fourn(w,nn,2,-1);
     for (j=1;j<=lattice_size_y;j++)
      for (i=1;i<=lattice_size_x;i++)
       fprintf(fp2,"%f\n",w[2*(i-1)*lattice_size_y+2*j-1]
        /(lattice_size_x*lattice_size_y));
     fclose(fp1);
     fclose(fp2);
}
