#include<malloc.h>
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
#include"nr.h"
#include"nrutil.h"

#define PI 3.141592653589793

main()
{    FILE *fp1;
     int idum,*iup,*idown,count,printed,outputinterval,length_y,lattice_size_x,i;
     float courantwave,courantdiff,maxdelw,del,*h2,*w2,h0,*flux,*deltaw,*deltah;
     float w0,simulationlength,deltax,elapsedtime,timestep,channelslope;
     float *height,*heightold,*width,*widthold,maxheightchange; 

     fp1=fopen("channeloscillations","w");
     lattice_size_x=100;
     deltax=100;          /* m */
     idum=-76;
     channelslope=0.01;   /* m/m */
     w0=100;              /* m */
     h0=1;                /* m */
     iup=ivector(1,lattice_size_x);
     idown=ivector(1,lattice_size_x);
     height=vector(1,lattice_size_x);
     heightold=vector(1,lattice_size_x);
     deltah=vector(1,lattice_size_x);
     width=vector(1,lattice_size_x);
     widthold=vector(1,lattice_size_x);
     deltaw=vector(1,lattice_size_x); 
     flux=vector(1,lattice_size_x);
     h2=vector(1,lattice_size_x);
     w2=vector(1,lattice_size_x);
     simulationlength=5000000.0; /* yr */ 
     outputinterval=100000.0;
     for (i=1;i<=lattice_size_x;i++)
      {width[i]=w0;
       widthold[i]=width[i];
       height[i]=-0.05*sin((i-1)*2*PI*3/(lattice_size_x-1))+0.03*gasdev(&idum);
       heightold[i]=height[i];
       flux[i]=0;h2[i]=0;w2[i]=0;
       deltaw[i]=0;deltah[i]=0;
       iup[i]=i+1;idown[i]=i-1;}
     iup[lattice_size_x]=1;idown[1]=lattice_size_x;
     timestep=1;
     elapsedtime=0.0;
     printed=0;
     while (elapsedtime<simulationlength)
      {printed=elapsedtime/outputinterval;
       maxdelw=0;
       for (i=1;i<=lattice_size_x;i++)
        flux[i]=((heightold[idown[i]]-heightold[i])/deltax+channelslope)/widthold[i];
       for (i=1;i<=lattice_size_x;i++)
        {del=0.5*timestep/deltax*(flux[idown[i]]-flux[i]);
         h2[i]=0.5*(heightold[idown[i]]+heightold[i])+del;
         w2[i]=widthold[i]-0.5*timestep*0.5*
          (flux[idown[i]]+flux[i]-2*channelslope/w0)/(h0-h2[i]);}
       for (i=1;i<=lattice_size_x;i++)
        flux[i]=((h2[i]-h2[iup[i]])/deltax+channelslope)/w2[i];
       for (i=1;i<=lattice_size_x;i++) 
        {del=timestep/deltax*(flux[i]-flux[iup[i]]);
         height[i]+=del;
         width[i]-=0.5*timestep*(flux[iup[i]]+flux[i]-
          2*channelslope/w0)/(h0-heightold[i]);
         if (fabs(widthold[idown[i]]-widthold[iup[i]])/widthold[i]>maxdelw)
          maxdelw=fabs(widthold[idown[i]]-widthold[iup[i]])/widthold[i];
         if (width[i]<10) width[i]=10;
         if (width[i]>300) width[i]=300;}
       elapsedtime+=timestep;
       if ((maxdelw>0.5*deltax/timestep)||(timestep>deltax*deltax))
         {elapsedtime-=timestep;
          timestep/=2.0;
          for (i=1;i<=lattice_size_x;i++)
           {height[i]=heightold[i];
            width[i]=widthold[i];}}
        else 
          if ((maxdelw<0.5*deltax*deltax/timestep/10)&&(timestep<deltax*deltax/10))
           timestep*=1.2;
       for (i=1;i<=lattice_size_x;i++)
         {heightold[i]=height[i];
          widthold[i]=width[i];}
       if ((int)(elapsedtime/outputinterval)>printed)
        {for (i=1;i<=lattice_size_x;i++)
          fprintf(fp1,"%d %f %f\n",i,height[i]/h0,width[i]/w0);
         printed=(int)(elapsedtime/outputinterval);}}
     fclose(fp1);
}  
