#include<malloc.h>
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
#include"nr.h"
#include"nrutil.h"

main()
{    float *precyear,beta,sum,sddevcomp,mean,sddev;
     int length,year,format; 
     int idum;
     char outputfile[30];
     FILE *fp;   
     
     printf("\nName of output file: ");
     scanf("%s",outputfile);
     printf("\nLength of desired noise: (factor of two, please) ");
     scanf("%d",&length);
     printf("\nGaussian or Log-normal dataset? (1 for gaussian 2 for l-n): ");
     scanf("%d",&format);
     printf("\nMean: (if log-normal this mean is that of the final, 
      log transformed data) ");
     scanf("%f",&mean);
     printf("\nStandard Dev: ");
     scanf("%f",&sddev);
     printf("\nBeta: ");
     scanf("%f",&beta);
     printf("\nRandom number seed: (any negative integer) ");
     scanf("%d",&idum);      
     fp=fopen(outputfile,"w");
     precyear=vector(1,2*length);
     /*we contruct a vector of length two times the input length so that we
     may cut off the ends to eliminate the periodicity introduced by filtering*/
     for (year=1;year<=2*length;year++) 
       precyear[year]=gasdev(&idum);    
     realft(precyear,2*length,1);
     precyear[1]=0.0;
     precyear[2]=precyear[2]/pow(0.5,beta/2.0);
     for (year=3;year<=2*length;year++) 
       precyear[year]=precyear[year]/pow((year/2)/(float)(2*length),beta/2.0);
     realft(precyear,2*length,-1);
     sum=0.0;
     for (year=length/2;year<=length+length/2;year++) 
        {sum+=precyear[year];}
     sum=sum/length; 
     sddevcomp=0.0;
     for (year=length/2;year<=length+length/2;year++)
       sddevcomp+=(precyear[year]-sum)*(precyear[year]-sum); 
     sddevcomp=sddevcomp/length;
     /*below we rescale the amplitudes to restore the desired moments*/
     for (year=length/2;year<=length+length/2;year++)
      {precyear[year]=(precyear[year]-sum)/sqrt(sddevcomp);
       precyear[year]=(precyear[year]*sddev)+mean;
       if (format==2) if (mean!=0.0) precyear[year]=
        sqrt(log(1+sddev*sddev/(mean*mean)))*precyear[year]+
         log(mean/sqrt(1+sddev*sddev/(mean*mean)));}
     if (format==2) for (year=length/2;year<=length+length/2;year++)
      precyear[year]=exp(precyear[year]);
     for (year=length/2;year<=length+length/2;year++)
      fprintf(fp,"%d %f\n",year-length/2,precyear[year]+(float)(year-length/2)/(length));
     fclose(fp);
}   
