#include<malloc.h>
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
#include"nr.h"
#include"nrutil.h"

main()
{
     FILE *fp1,*fp2;
     float rf,rr,rc,*f,kappaT,deltax,a,*prefact,*topo,*J0rr,*J0rc,*J1rr,*J1rc;
     float *J0rf,*J1rf,*Intrf,*J0r0,*J1r0,*Intrr,*Intrc;
     int lattice_size_x,i,nsum;

     fp1=fopen("besselzerosintegral","r");
     fp2=fopen("volcanicconeoutput","w");
     kappaT=0.0001;  /* dimensionless  scaled to a^2 */
     lattice_size_x=300; 
     deltax=10.0;  
     a=lattice_size_x*deltax;
     rf=200.0/a;
     rr=500.0/a;
     rc=1500.0/a;
     topo=vector(1,lattice_size_x);
     f=vector(1,lattice_size_x);
     zeros=vector(1,300);
     J0rc=vector(1,300);
     J1rc=vector(1,300);
     Intrc=vector(1,300);
     J0rr=vector(1,300);
     J1rr=vector(1,300);
     Intrr=vector(1,300);
     J0rf=vector(1,300);
     J1rf=vector(1,300);
     Intrf=vector(1,300);
     prefact=vector(1,300);
     for (nsum=1;nsum<=300;nsum++)
      {fscanf(fp1,"%f %f %f %f",&zeros[nsum],&Intrf[nsum],&Intrr[nsum],&Intrc[nsum]);
       J0rc[nsum]=bessj0(rc*zeros[nsum]);
       J1rc[nsum]=bessj1(rc*zeros[nsum]);
       J0rr[nsum]=bessj0(rr*zeros[nsum]);
       J1rr[nsum]=bessj1(rr*zeros[nsum]);
       J0rf[nsum]=bessj0(rf*zeros[nsum]);
       J1rf[nsum]=bessj1(rf*zeros[nsum]);}
     for (i=1;i<=lattice_size_x;i++)
      {if (i*deltax/a<rf) 
        f[i]=1+(rf-rr)/(rc-rr);
       else if (i*deltax/a<rr)
        f[i]=1+(i*deltax/a-rr)/(rc-rr);
       else if (i*deltax/a<rc)
        f[i]=1+(rr-i*deltax/a)/(rc-rr);
       else f[i]=0;
       /* print initial condition first */
       fprintf(fp2,"%f %12.10f\n",i*deltax,f[i]);}
     for (i=1;i<=lattice_size_x;i++)
      topo[i]=0; 
     for (nsum=1;nsum<=300;nsum++)
      prefact[nsum]=2.0/zeros[nsum]*exp(-kappaT*zeros[nsum]*zeros[nsum])/
       (bessj1(zeros[nsum])*bessj1(zeros[nsum]));
     for (i=1;i<=lattice_size_x;i++)
      {for (nsum=1;nsum<=300;nsum++)
        topo[i]+=prefact[nsum]*bessj0(zeros[nsum]*i*deltax/a)*(rf*rf/(rc-rr)*
         J1rf[nsum]-2*rr*rr/(rc-rr)*J1rr[nsum]+(1+rr/(rc-rr))*
         rc*J1rc[nsum]+2*zeros[nsum]/(rc-rr)*Intrr[nsum]-zeros[nsum]/
         (rc-rr)*(Intrf[nsum]+Intrc[nsum]));
       fprintf(fp2,"%f %12.10f\n",i*deltax,topo[i]);} 
   fclose(fp1);
   fclose(fp2); 
}
