#include<malloc.h>
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
#include"nr.h"
#include"nrutil.h"

#define N 2
#define epssm 0.0001

float *xp,**yp,dxsav,a,eps;
int kmax,kount,*iup,*jup,*idown,*jdown;

void derivs(x,y,dydx)
float dydx[],x,y[];
{
        dydx[1]=y[2];
        dydx[2]=(y[2]*(1-y[2])*(y[2]-a)-y[1])/eps;
}
main()
{    FILE *fp1;
     int nbad,nok,t,lattice_size_x,i;
     float *sol,h1=0.1,hmin=0.0,x1,x2,*lap,deltax,fac;
     float *u,*v,timestep,kappa;

     fp1=fopen("spiralmodel1d","w"); 
     a=0.2;
     eps=0.05;
     deltax=0.2;
     timestep=deltax*deltax/5;
     kappa=timestep/(deltax*deltax);
     lattice_size_x=512;
     u=vector(1,lattice_size_x);
     v=vector(1,lattice_size_x);
     lap=vector(1,lattice_size_x);
     sol=vector(1,2);
     iup=ivector(1,lattice_size_x);
     idown=ivector(1,lattice_size_x);
     for (i=1;i<=lattice_size_x;i++)
      {iup[i]=i+1;
       idown[i]=i-1;}
     iup[lattice_size_x]=1;
     idown[1]=lattice_size_x;
     for (i=1;i<=lattice_size_x;i++)
      if ((i>lattice_size_x/2-5)&&(i<lattice_size_x/2-2)) 
       {u[i]=0.25;v[i]=0.0;} 
      else 
       {u[i]=0;v[i]=0;}
     /* plot initial condition first */
     for (i=1;i<=lattice_size_x;i++)
      fprintf(fp1,"%f %f %f\n",(i-lattice_size_x/2)/10.0,u[i],-v[i]);
     fac=timestep*kappa/deltax/deltax;
     x1=0;x2=timestep;
     for (t=1;t<=1000;t++)
      {for (i=1;i<=lattice_size_x;i++)
        lap[i]=0;
       for (i=1;i<=lattice_size_x;i++)
        {sol[1]=v[i];sol[2]=u[i];
         odeint(sol,N,x1,x2,epssm,h1,hmin,&nok,&nbad,derivs,rkqs);
         v[i]=sol[1];u[i]=sol[2];
         if (fabs(u[i])>0.00001) {lap[i]=-2*u[i];lap[iup[i]]=u[i];lap[idown[i]]=u[i];}}
       for (i=1;i<=lattice_size_x;i++)
        if (fabs(lap[i])>0) u[i]+=fac*lap[i];}
     for (i=1;i<=lattice_size_x;i++)
      fprintf(fp1,"%f %f %f\n",(i-lattice_size_x/2)/10.0,u[i],-v[i]);
     fclose(fp1);
}  
