#include<malloc.h>
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
#include"nr.h"
#include"nrutil.h"

#define maxoutputlength 10000000

main()
{    FILE *fp1;
     int n,t,t2,idum,duration,nsteps;
     float tau,per,drift,eta,*T,*B,Bh,*v,deltaT,timestep;

     fp1=fopen("iceagemodel","w");
     T=vector(1,maxoutputlength);   
     B=vector(1,maxoutputlength);
     v=vector(1,maxoutputlength);
     eta=0.9;
     tau=75;
     drift=0.2;
     T[1]=0;B[1]=0;v[1]=0;
     idum=-7834;
     timestep=100;      /* yr */
     duration=3000000;  /* yr */
     nsteps=(int)(duration/timestep);
     for (t=1;t<=nsteps;t++) 
      {if (T[t]<-1) deltaT=-T[t]-3.2*sqrt(-1-T[t])+eta*gasdev(&idum)+drift; 
        else deltaT=-T[t]+eta*gasdev(&idum)+drift;
       Bh=0;
       for (t2=t-2*tau;t2<t;t2++)
        if (t2>1) Bh+=-(T[t2]-1)*exp(-fabs(t-t2)/tau)/tau; 
       B[t+1]=Bh;
       if (T[t]<-1) v[t+1]=fabs(B[t+1]-B[t]); else v[t+1]=0; 
       deltaT+=25*v[t+1];
       T[t+1]=T[t]+deltaT;
       fprintf(fp1,"%d %f %f %f\n",t*100.0,T[t],v[t+1],Bh);}
     fclose(fp1);
}     
